/*
 *	spTopLevel_Win.h
 */

#ifndef __SPTOPLEVEL_WIN_H
#define __SPTOPLEVEL_WIN_H

#include <sp/spComponent_Win.h>

#ifdef __cplusplus
extern "C" {
#endif

#define SP_FIND_EXECUTED_APPLICATION_COPYDATA_ID 1000

#define SP_WINDOW_CLASS_NAME "spWindow"
#define SP_CANVAS_CLASS_NAME "spCanvas"

#define SP_ACCEL_BUFFER 16

typedef struct _spTopLevelArchPart {
    CRITICAL_SECTION critical_section;
    DWORD main_thread_id;
    
    HINSTANCE hThisInst;
    HINSTANCE hPrevInst;
    int nWinMode;
    MSG msg;
    HFONT sys_font;
    HPEN null_pen;
    HBRUSH null_brush;
    HBRUSH bg_brush;
    HCURSOR hcursor;

    HANDLE hmutex;
    spBool getting_message;

    OSVERSIONINFO osver;
    
    HWND task_bar;
    HWND start_button;

    int dpiX, dpiY;
} spTopLevelArchPart;

extern int spWinMainInitialize(HINSTANCE hThisInst, HINSTANCE hPrevInst, int nWinMode);
extern char **spConvertArgsToArgv(LPSTR lpszArgs, char *program_name, int *argcp);
extern void spFreeArgv(int argc, char **argv);

extern char *spGetHelpFileWin(DWORD *pdwCookie);
extern spBool spIsOSWinNT(void);
extern spBool spIsOSWinXPLater(void);
extern spBool spIsOSWinVistaLater(void);
extern spBool spIsOSWin7Later(void);
    
extern int spGetDPIXWin(spTopLevel toplevel);
extern int spGetDPIYWin(spTopLevel toplevel);
extern int spScaleXWin(spTopLevel toplevel, int x);
extern int spScaleYWin(spTopLevel toplevel, int x);
extern int spUnscaleXWin(spTopLevel toplevel, int x);
extern int spUnscaleYWin(spTopLevel toplevel, int y);
extern int spPointToPixelWin(spTopLevel toplevel, int pt);
extern void spScaleRectWin(spTopLevel toplevel, RECT *pRect);
extern int spGetScaledScreenWidthWin(spTopLevel toplevel);
extern int spGetScaledScreenHeightWin(spTopLevel toplevel);

extern spBool spMapTaskBarWindow(spTopLevel toplevel);
extern spBool spUnmapTaskBarWindow(spTopLevel toplevel);
    
#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPTOPLEVEL_WIN_H */
