/*
 *	spStatusBar_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>

#include <sp/spStatusBarP.h>

void spStatusBarPartInitArch(spComponent component)
{
    SpStatusBarArch(component).total_size = 0;
    SpStatusBarArch(component).last_frame = NULL;
    return;
}

void spStatusBarPartFreeArch(spComponent component)
{
    return;
}

void spStatusBarCreateArch(spComponent component, int *num_item)
{
    int i;
    int num_label = 0;
    GtkWidget *frame, *label;
    
#if GTK_CHECK_VERSION(3,0,0)
    SpPrimitiveArch(component).widget = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
#else
    SpPrimitiveArch(component).widget = gtk_hbox_new(FALSE, 0);
#endif

#if 0
    spPrimitiveContainerAddGtk(component);
#else
    gtk_box_pack_end(GTK_BOX(SpParentPrimitiveArch(component).top_widget),
		     SpPrimitiveArch(component).widget, FALSE, FALSE, 0);
    if (SpComponentPart(component).visible_flag == SP_TRUE) {
	gtk_widget_show(SpPrimitiveArch(component).widget);
    }
#endif

    SpStatusBarArch(component).total_size = 0;
    
    for (i = 0; i < SP_MAX_STATUS_ITEM; i++) {
	if (SpStatusBarPart(component).item_sizes == NULL
	    || SpStatusBarPart(component).item_sizes[i] <= 0) {
	    if (SpStatusBarPart(component).use_last_item == SP_TRUE
		|| i <= 0) {
		SpStatusBarPart(component).use_last_item = SP_TRUE;
		num_label = i + 1;
		    
		frame = gtk_frame_new(NULL);
		gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
		gtk_box_pack_start(GTK_BOX(SpPrimitiveArch(component).widget),
				   frame, TRUE, TRUE, 0);
		gtk_widget_show(frame);
		    
		label = gtk_label_new("");
#if GTK_CHECK_VERSION(1,2,0)
		gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
#else
		gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
#endif
		gtk_container_add(GTK_CONTAINER(frame), label);
		gtk_widget_show(label);

		SpStatusBarArch(component).last_frame = frame;
	    } else {
		num_label = i;
	    }
	    break;
	} else {
	    SpStatusBarArch(component).total_size += SpStatusBarPart(component).item_sizes[i];
		
	    frame = gtk_frame_new(NULL);
	    gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
#if GTK_CHECK_VERSION(3,0,0)
	    gtk_widget_set_size_request(frame,
					SpStatusBarPart(component).item_sizes[i], -1);
#else
	    gtk_widget_set_usize(frame,
				 SpStatusBarPart(component).item_sizes[i], -1);
#endif
	    gtk_box_pack_start(GTK_BOX(SpPrimitiveArch(component).widget),
			       frame, FALSE, FALSE, 0);
	    gtk_widget_show(frame);
		
	    label = gtk_label_new("");
#if GTK_CHECK_VERSION(1,2,0)
	    gtk_misc_set_alignment(GTK_MISC(label), 0.0, 0.5);
#else
	    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
#endif
	    gtk_container_add(GTK_CONTAINER(frame), label);
	    gtk_widget_show(label);
	}
    }

    *num_item = num_label;

    return;
}

void spStatusBarSetParamsArch(spComponent component)
{
    return;
}

void spStatusBarDestroyArch(spComponent component)
{
    return;
}

spBool spSetStatusTextArch(spComponent component, int index, const char *string)
{
    int i;
    GList *children;
    
    
#if GTK_CHECK_VERSION(3,0,0)
    children = gtk_container_get_children(GTK_CONTAINER(SpPrimitiveArch(component).widget));
#else
    children = gtk_container_children(GTK_CONTAINER(SpPrimitiveArch(component).widget));
#endif
    
    for (i = 0; children != NULL; i++) {
	if (i == index) {
	    if (children->data != NULL) {
#if GTK_CHECK_VERSION(3,0,0)
		children = gtk_container_get_children(GTK_CONTAINER(children->data));
#else
		children = gtk_container_children(GTK_CONTAINER(children->data));
#endif

		while (children != NULL) {
		    if (GTK_IS_LABEL(children->data) == TRUE) {
#if GTK_CHECK_VERSION(3,0,0)
			gtk_label_set_text(GTK_LABEL(children->data), string);
#else
			gtk_label_set(GTK_LABEL(children->data), string);
#endif
			return SP_TRUE;
		    }
		    children = children->next;
		}
	    }
	    break;
	}

	children = children->next;
    }
    
    return SP_FALSE;
}
